
<%@page import="com.liferay.portlet.asset.AssetRendererFactoryRegistryUtil"%>
<%@page import="com.liferay.portlet.asset.model.AssetRendererFactory"%>
<%@page import="it.tref.liferay.mapit.constants.Constants"%>
<%@page import="it.tref.liferay.mapit.map.util.MapItPluginPortletPreferencesUtil"%>
<%@page import="com.liferay.portal.kernel.util.HttpUtil"%>
<%@page import="it.tref.liferay.mapit.constants.WebKeys"%>
<%@page import="it.tref.liferay.mapit.map.service.PluginPortletPreferencesLocalServiceUtil"%>
<%@page import="com.liferay.portlet.PortletPreferencesFactoryUtil"%>
<%@page import="javax.portlet.PortletPreferences"%>
<%@page import="com.liferay.portal.model.PortletConstants"%>
<%@page import="it.tref.liferay.mapit.map.constants.PortletKeys"%>
<%@page import="com.liferay.portal.kernel.servlet.ServletContextPool"%>
<%@page import="com.liferay.portal.kernel.portlet.LiferayWindowState"%>
<%@page import="javax.portlet.PortletRequest"%>
<%@page import="com.liferay.portlet.PortletURLFactoryUtil"%>
<%@page import="it.tref.liferay.mapit.map.util.MapItPluginUtil"%>
<%@page import="it.tref.liferay.mapit.plugin.MapItPlugin"%>
<%@page import="com.liferay.portal.security.permission.ResourceActionsUtil"%>
<%@page import="com.liferay.portal.util.PortalUtil"%>
<%@page import="java.util.Arrays"%>
<%@page import="com.liferay.portal.kernel.util.ListUtil"%>
<%@page import="com.liferay.portal.kernel.util.ArrayUtil"%>
<%@page import="com.liferay.portal.kernel.util.KeyValuePairComparator"%>
<%@page import="com.liferay.portal.kernel.util.KeyValuePair"%>
<%@page import="com.liferay.portal.kernel.portlet.DefaultConfigurationAction"%>
<%@page import="com.liferay.portal.kernel.exception.PortalException"%>

<%@include file="/html/map/init.jsp" %>

<%

String portletResource = ParamUtil.getString(request, "portletResource");

String contextName = ParamUtil.getString(request, "contextName");

String tab = ParamUtil.getString(request, "tabs2", "display-settings");
%>

<c:choose>
	<c:when test="<%=Validator.isNotNull(contextName) %>">
	
		<%
		
		PortletPreferences preferences = MapItPluginPortletPreferencesUtil.getPortletPreferences(
		    companyId, plid, portletResource, contextName);
		request.setAttribute(WebKeys.PLUGIN_PORTLET_PREFERENCES, preferences);
		
		Plugin plugin = PluginLocalServiceUtil.getPlugin(contextName);
		
		PortletURL portletURL = PortletURLFactoryUtil.create(request, PortletKeys.PORTLET_CONFIGURATION,
		    plid, PortletRequest.RENDER_PHASE);
		portletURL.setParameter("portletResource", portletResource);
		portletURL.setParameter("struts_action", "/portlet_configuration/edit_configuration");
		portletURL.setParameter("tabs2", "plugins");
		portletURL.setWindowState(windowState);
		%>
		
		<liferay-ui:header 
			backURL='<%=portletURL.toString() %>'
			escapeXml="<%=false %>"
			localizeTitle="<%=false %>"
			title='<%=plugin.getName() %>' />
	
		<liferay-util:include servletContext="<%=ServletContextPool.get(contextName) %>"
			page='<%=MapItPluginUtil.getMapItPlugin(contextName).getPortletConfigurationJsp() %>' />
			
	</c:when>
	<c:otherwise>
	
		<liferay-ui:tabs
			formName="fm"
			names="display-settings,plugins"
			param="tabs2"
			refresh="<%= false %>"
		>
			<liferay-ui:section>
			
				<liferay-portlet:actionURL var="url" portletConfiguration="true">
					<liferay-portlet:param name="redirectUrl" value="<%=currentURL %>"/>
				</liferay-portlet:actionURL>
				
				<aui:form method="post" action="<%=url %>" name="fm" onSubmit="event.preventDefault();" >
					<aui:input name="<%=Constants.CMD%>" type="hidden" value="<%=Constants.UPDATE%>" />
					<aui:input name="tabs2" type="hidden" value="<%=tab%>" />
				
					<liferay-ui:error-marker key="errorSection" value="display-settings" />	
		
					<liferay-ui:panel collapsible="<%= true %>" extended="<%= true %>" 
						id='<%= renderResponse.getNamespace() + "parametersListingPanel" %>' 
						persistState="<%= true %>" 
						title="label-mapitmap-configuration-general-title">
						
						<aui:fieldset>
							<div class="row-fields">
								<div class="field-row query-row">
									<div class="field">
										<aui:select name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.MAP_TYPE + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.MAP_TYPE %>" 
											label="label-mapitmap-configuration-general-maptype">
											<aui:option value="<%=Constants.MapTypeValue.OPEN_STREET_MAP %>" 
												selected="<%=mapType.equals(Constants.MapTypeValue.OPEN_STREET_MAP) %>">
												<liferay-ui:message key="label-mapitmap-configuration-maptype-openstreetmap" />
											</aui:option>
											<aui:option value="<%=Constants.MapTypeValue.GOOGLE_MAP %>" 
												selected="<%=mapType.equals(Constants.MapTypeValue.GOOGLE_MAP) %>">
												<liferay-ui:message key="label-mapitmap-configuration-maptype-googlemap" />
											</aui:option>
											<aui:option value="<%=Constants.MapTypeValue.BING_MAP %>" 
												selected="<%=mapType.equals(Constants.MapTypeValue.BING_MAP) %>">
												<liferay-ui:message key="label-mapitmap-configuration-maptype-bingmap" />
											</aui:option>
											<aui:option value="<%=Constants.MapTypeValue.BASE_MAP %>" 
												selected="<%=mapType.equals(Constants.MapTypeValue.BASE_MAP) %>">
												<liferay-ui:message key="label-mapitmap-configuration-maptype-base" />
											</aui:option>
											<aui:option value="<%=Constants.MapTypeValue.BASE_MAP_LABEL %>" 
												selected="<%=mapType.equals(Constants.MapTypeValue.BASE_MAP_LABEL) %>">
												<liferay-ui:message key="label-mapitmap-configuration-maptype-baselabel" />
											</aui:option>
										</aui:select>
									</div>
									<div id='<%= renderResponse.getNamespace() + "divMapStyles" %>' 
										class='field <%= mapType.equals(Constants.MapTypeValue.GOOGLE_MAP) ? StringPool.BLANK : "hide" %>'>
										<aui:input style="height: 15em; width: 100%;"
											label="label-mapitmap-configuration-general-mapstyles"
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.MAP_STYLES + StringPool.DOUBLE_DASH %>" 
											type="textarea" 
											value="<%= mapStyles %>" 
										/>
									</div>
									<div id='<%= renderResponse.getNamespace() + "divApiKey" %>' 
										class='field <%= mapType.equals(Constants.MapTypeValue.GOOGLE_MAP) || mapType.equals(Constants.MapTypeValue.BING_MAP) ? StringPool.BLANK : "hide" %>'>
										<aui:input inlineField="<%= true %>" label="label-mapitmap-configuration-general-api-key" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.API_KEY + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.API_KEY %>"  
											showRequiredLabel="<%= false %>"
											value="<%=apiKey %>" >
											<c:if test="<%= mapType.equals(Constants.MapTypeValue.BING_MAP)  %>">
												<aui:validator name="required" />
											</c:if>
										</aui:input>
									</div>
									<div id='<%= renderResponse.getNamespace() + "divApiVersion" %>' 
										class='field <%= mapType.equals(Constants.MapTypeValue.GOOGLE_MAP) ? StringPool.BLANK : "hide" %>'>
										<aui:input inlineField="<%= true %>" label="label-mapitmap-configuration-general-api-version" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.API_VERSION + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.API_VERSION %>"  
											showRequiredLabel="<%= false %>"
											value="<%=apiVersion %>" />
									</div>
									<div class="field">
										<aui:input inlineField="<%= true %>" label="label-mapitmap-configuration-general-center-lat" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.CENTER_LAT + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.CENTER_LAT %>"  
											value="<%=centerLatitude %>">
											<aui:validator name="custom" errorMessage="you-have-entered-invalid-data">
											    function(val, fieldNode, ruleValue) { 					    	
											    	return /^([-]{0,1}[0-9]{1,3}([.][0-9]{1,9}){0,1})$/.test(val);  
											    }
											</aui:validator>
										</aui:input>
									</div>
									<div class="field">
										<aui:input inlineField="<%= true %>"  label="label-mapitmap-configuration-general-center-lon" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.CENTER_LON + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.CENTER_LON %>" 
											value="<%=centerLongitude %>">
											<aui:validator name="custom" errorMessage="you-have-entered-invalid-data">
											    function(val, fieldNode, ruleValue) { 					    	
											    	return /^([-]{0,1}[0-9]{1,3}([.][0-9]{1,9}){0,1})$/.test(val);  
											    }
											</aui:validator>
										</aui:input>
									</div>
									<div class="field">
										<aui:input label="label-mapitmap-configuration-general-geobrowser" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.GEO_BROWSER + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.GEO_BROWSER %>"  
											checked="<%= geoBrowser  %>"  
											type="checkbox"/>
									</div>
									<div class="field">	
										<aui:select inlineField="<%= true %>" label="label-mapitmap-configuration-general-zoomfactor" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.ZOOM_FACTOR + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.ZOOM_FACTOR %>" >
											<%
											int zoom = Integer.parseInt(centerZoom);
											for (int i=1;i<=21;i++) {%>
												<aui:option label='<%=i %>' value='<%=i %>' selected="<%=zoom == i %>" />
											<%
											} 
											%>
										</aui:select>
									</div>
									<div class="field">						
										<aui:input label="label-mapitmap-configuration-general-height" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.HEIGHT + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.HEIGHT %>" showRequiredLabel="false"
											value='<%=mapHeight%>'>
											<aui:validator name="required" />
											<aui:validator name="number" />
										</aui:input>
									</div>
									<div class="field">
										<aui:input label="label-mapitmap-configuration-general-savelastposition" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.SAVE_LAST_POSITION + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.SAVE_LAST_POSITION %>"  
											checked="<%= saveLastPosition %>"  
											type="checkbox"/>
									</div>
									<div class="field">
										<aui:input label="label-mapitmap-configuration-general-show-map-code" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.SHOW_MAP_CODE + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.SHOW_MAP_CODE %>"  
											checked="<%= showMapCode %>"  
											type="checkbox"/>
									</div>
									
								</div>
							</div>	
						</aui:fieldset>		
					</liferay-ui:panel>
					
					<liferay-ui:panel collapsible="<%= true %>" extended="<%= true %>" 
						id='<%= renderResponse.getNamespace() + "controlListingPanel" %>' 
						persistState="<%= true %>"
						title="label-mapitmap-configuration-control-title">
						 
						<aui:fieldset>
						
							<div class="row-fields">
								<div class="field-row query-row">
									<div class="field">
										<aui:input label="label-mapitmap-configuration-control-layerswitch" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.LAYER_SWITCH + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.LAYER_SWITCH %>" 
											checked="<%= layerSwitch %>" 
											type="checkbox"/>
									</div>
									<div class="field">
										<aui:input label="label-mapitmap-configuration-control-fullscreen" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.FULL_SCREEN + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.FULL_SCREEN %>" 
											checked="<%= fullScreen %>" 
											type="checkbox"/>
									</div>
									<div class="field">
										<aui:input label="label-mapitmap-configuration-control-navtoolbar" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.NAV_TOOLBAR + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.NAV_TOOLBAR %>" 
											checked="<%= navToolbar %>" 
											type="checkbox"/>
									</div>
									<div class="field">
										<aui:input label="label-mapitmap-configuration-control-mouseposition" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.MOUSE_POSITION + StringPool.DOUBLE_DASH %>"
											id="<%=PortletConfiguration.MOUSE_POSITION %>" 
											checked="<%= mousePosition %>"
											type="checkbox"/>
									</div>
									<div class="field">
										<aui:input label="label-mapitmap-configuration-control-scale" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.SCALE + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.SCALE %>" 
											checked="<%= scale %>"  
											type="checkbox"/>
									</div>
									<div class="field">
										<aui:input label="label-mapitmap-configuration-control-home" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.HOME + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.HOME %>" 
											checked="<%= home %>"  
											type="checkbox"/>
									</div>
									<div class="field">
										<aui:input label="label-mapitmap-configuration-control-overviewmap" 
											name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.OVERVIEW_MAP + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.OVERVIEW_MAP %>" 
											checked="<%= overviewMap %>"  
											type="checkbox"/>
									</div>
									<div class="field">
										<aui:select name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.ZOOM_TYPE + StringPool.DOUBLE_DASH %>" 
											id="<%=PortletConfiguration.ZOOM_TYPE %>" 
											label="label-mapitmap-configuration-control-zoomtype">
											<aui:option value="" selected="<%=Validator.isNull(zoomType) %>">
												<liferay-ui:message key="label-mapitmap-configuration-control-zoomtype-no" />
											</aui:option>
											<aui:option value="<%=Constants.ZoomTypeValue.SIMPLE %>" 
												selected="<%=zoomType.equals(Constants.ZoomTypeValue.SIMPLE) %>">
												<liferay-ui:message key="label-mapitmap-configuration-control-zoomtype-simple" />
											</aui:option>
											<aui:option value="<%=Constants.ZoomTypeValue.COMPACT %>" 
												selected="<%=zoomType.equals(Constants.ZoomTypeValue.COMPACT) %>">
												<liferay-ui:message key="label-mapitmap-configuration-control-zoomtype-compact" />
											</aui:option>
											<aui:option value="<%=Constants.ZoomTypeValue.FULL %>" 
												selected="<%=zoomType.equals(Constants.ZoomTypeValue.FULL) %>">
												<liferay-ui:message key="label-mapitmap-configuration-control-zoomtype-full" />
											</aui:option>
										</aui:select>
									</div>
								</div>
							</div>
						</aui:fieldset>		
					</liferay-ui:panel>
					
					
					<liferay-ui:panel collapsible="<%= true %>" extended="<%= true %>" 
						id='<%= renderResponse.getNamespace() + "popupListingPanel" %>' 
						persistState="<%= true %>"
						title="label-mapitmap-configuration-popup-title">
						
						<div class="field">
							<aui:input label="label-mapitmap-configuration-popup-no-popup" 
								name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.NO_POPUP + StringPool.DOUBLE_DASH %>" 
								id="<%=PortletConfiguration.NO_POPUP %>" 
								checked="<%= noPopup %>"  
								type="checkbox"/>
						</div>
						
					</liferay-ui:panel>
					
					<liferay-ui:panel collapsible="<%= true %>" extended="<%= true %>" 
						id='<%= renderResponse.getNamespace() + "sourceListingPanel" %>' 
						persistState="<%= true %>" 
						title="label-mapitmap-configuration-source-title">
						
						<aui:input name="preferences--classNameIds--" type="hidden" />
						
						<h5> <liferay-ui:message key="asset-entries" /> </h5>
				
						<%
			
						// Left list
			
						List<KeyValuePair> typesLeftList = new ArrayList<KeyValuePair>();
						
						for (long classNameId : classNameIds) {
						  try{
							String className = PortalUtil.getClassName(classNameId);
			
							typesLeftList.add(new KeyValuePair(String.valueOf(classNameId), ResourceActionsUtil.getModelResource(locale, className)));
						  }catch(Exception e){
						  }
						}
			
						// Right list
			
						List<KeyValuePair> typesRightList = new ArrayList<KeyValuePair>();
						for (long classNameId : availableClassNameIds) {
							if(!ArrayUtil.contains(classNameIds, classNameId)){
								 try{
									String className = PortalUtil.getClassName(classNameId);
			
									typesRightList.add(new KeyValuePair(String.valueOf(classNameId), ResourceActionsUtil.getModelResource(locale, className)));
								 }catch(Exception e){
								 }
							}
						}
						
						Arrays.sort(classNameIds);
						
						typesRightList = ListUtil.sort(typesRightList, new KeyValuePairComparator(false, true));
						%>
			
						<liferay-ui:input-move-boxes
							leftBoxName="currentClassNameIds"
							leftList="<%= typesLeftList %>"
							leftReorder="true"
							leftTitle="selected"
							rightBoxName="availableClassNameIds"
							rightList="<%= typesRightList %>"
							rightTitle="available"
						/>
						
						<%
						long[] noIndexerClassNameIds = AssetUtil.getAvailableIndexerClassNameIds(companyId, false);
						%>
						
						<c:if test="<%=noIndexerClassNameIds.length > 0 %>">
						
							<div class="alert alert-info">
								<liferay-ui:message key="label-mapitmap-configuration-resources-do-not-have-an-indexer-class-configured" />
							</div>
							
							<liferay-ui:search-container
								total="<%= noIndexerClassNameIds.length %>"
							>
								<liferay-ui:search-container-results
									results="<%= ListUtil.toList(noIndexerClassNameIds)  %>"
								/>
							
								<liferay-ui:search-container-row
									className="java.lang.Long"
									modelVar="noIndexerClassNameId"
								>
									
									<liferay-ui:search-container-column-text
										buffer="buffer"
										name="resource"
									>
							
										<%
										
										AssetRendererFactory assetRendererFactory 
											= AssetRendererFactoryRegistryUtil.getAssetRendererFactoryByClassName(
											    PortalUtil.getClassName(noIndexerClassNameId));
										
										buffer.append("<img align=\"left\" border=\"0\" src=\"");
										buffer.append(assetRendererFactory.getIconPath(liferayPortletRequest));
										buffer.append("\" style=\"margin-right: 5px;\">");
										buffer.append(ResourceActionsUtil.getModelResource(pageContext,
										    assetRendererFactory.getClassName()));
										%>
							
									</liferay-ui:search-container-column-text>
								
								</liferay-ui:search-container-row>
								
								<liferay-ui:search-iterator paginate="false" />
								
							</liferay-ui:search-container>
							
						</c:if>
						
						<%-- 
						<div class="field">
							<aui:input label="label-mapitmap-configuration-resources-ignore-view-permission" 
								name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.IGNORE_VIEW + StringPool.DOUBLE_DASH %>" 
								id="<%=PortletConfiguration.IGNORE_VIEW %>"  
								checked="<%= ignoreView  %>"  
								type="checkbox"/>
						</div>
						--%>
						
						<div class="field">
							<aui:input label="label-mapitmap-configuration-resources-ignore-bbox" 
								name="<%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.IGNORE_BBOX + StringPool.DOUBLE_DASH %>" 
								id="<%=PortletConfiguration.IGNORE_BBOX %>"  
								checked="<%= ignoreBbox  %>"  
								type="checkbox"/>
						</div>
						
					</liferay-ui:panel>
					
					<liferay-ui:panel collapsible="<%= true %>" extended="<%= true %>" 
						id='<%= renderResponse.getNamespace() + "pluginListingPanel" %>'
						persistState="<%= true %>" 
						title="label-mapitmap-configuration-plugin-title">
						
						<aui:input name="preferences--pluginIds--" type="hidden" />
						
						<aui:field-wrapper>
				
							<%
					
							// Left list
					
							List<KeyValuePair> typesLeftList = new ArrayList<KeyValuePair>();
							
							for (String pluginId : pluginIds) {
								Plugin plugin = PluginLocalServiceUtil.getPlugin(pluginId);
								if (plugin != null) {
								  typesLeftList.add(new KeyValuePair(String.valueOf(pluginId), plugin.getName()));
								}
							}
					
							// Right list
					
							List<KeyValuePair> typesRightList = new ArrayList<KeyValuePair>();
							for (String pluginId : availablePluginsIds) {
								if(!ArrayUtil.contains(pluginIds, pluginId)){
									Plugin plugin = PluginLocalServiceUtil.getPlugin(pluginId);
									typesRightList.add(new KeyValuePair(String.valueOf(pluginId), plugin.getName()));
								}
							}
					
							typesRightList = ListUtil.sort(typesRightList, new KeyValuePairComparator(false, true));
							%>
					
							<liferay-ui:input-move-boxes
								leftBoxName="currentPluginIds"
								leftList="<%= typesLeftList %>"
								leftReorder="true"
								leftTitle="selected"
								rightBoxName="availablePluginIds"
								rightList="<%= typesRightList %>"
								rightTitle="available"
							/>
						
						</aui:field-wrapper>
				
					</liferay-ui:panel>
					
					<aui:button-row>
						<aui:button onClick='<%= renderResponse.getNamespace() + "saveSelectBoxes();" %>' type="submit" />
					</aui:button-row>
					
				</aui:form>	
		
				<aui:script use="aui-base">
				
					A.one('#<portlet:namespace /><%=PortletConfiguration.MAP_TYPE %>').on('change', function(event){
					 	<portlet:namespace />openCloseApiKey();
					 	<portlet:namespace />openCloseMapStyles();
					 	<portlet:namespace />openCloseApiVersion();
					});
					
					Liferay.provide(
						window,
						'<portlet:namespace />openCloseApiKey',
						function() {		
						
							var A = new AUI();
							
							var value = A.one('#<portlet:namespace /><%=PortletConfiguration.MAP_TYPE %>').val();
							
							if(value == '<%=Constants.MapTypeValue.BING_MAP %>' || value == '<%=Constants.MapTypeValue.GOOGLE_MAP %>') {
								A.one('#<portlet:namespace />divApiKey').removeClass('hide');
							} else {
								A.one('#<portlet:namespace />divApiKey').addClass('hide');
							}
							
							var isRequired = (value == '<%=Constants.MapTypeValue.BING_MAP %>');
							
							var formValidator = Liferay.Form.get('<portlet:namespace/>fm').formValidator;
							var rules = formValidator.get('rules');
							
							rules['<portlet:namespace/><%=DefaultConfigurationAction.PREFERENCES_PREFIX + PortletConfiguration.API_KEY + StringPool.DOUBLE_DASH %>'] = {
								required: isRequired
							};
						},
						['aui-base']
					);
					
					Liferay.provide(
						window,
						'<portlet:namespace />openCloseMapStyles',
						function() {		
						
							var A = new AUI();
							
							var value = A.one('#<portlet:namespace /><%=PortletConfiguration.MAP_TYPE %>').val();
							
							if(value == '<%=Constants.MapTypeValue.GOOGLE_MAP %>') {
								A.one('#<portlet:namespace />divMapStyles').removeClass('hide');
							} else {
								A.one('#<portlet:namespace />divMapStyles').addClass('hide');
							}
						},
						['aui-base']
					);
					
					Liferay.provide(
						window,
						'<portlet:namespace />openCloseApiVersion',
						function() {		
						
							var A = new AUI();
							
							var value = A.one('#<portlet:namespace /><%=PortletConfiguration.MAP_TYPE %>').val();
							
							if(value == '<%=Constants.MapTypeValue.GOOGLE_MAP %>') {
								A.one('#<portlet:namespace />divApiVersion').removeClass('hide');
							} else {
								A.one('#<portlet:namespace />divApiVersion').addClass('hide');
							}
						},
						['aui-base']
					);
				  
					Liferay.provide(
						window,
						'<portlet:namespace />saveSelectBoxes',
						function() {		
							
							var mapType = A.one('#<portlet:namespace /><%=PortletConfiguration.MAP_TYPE %>').val();
							if (mapType != '<%=Constants.MapTypeValue.GOOGLE_MAP %>') {
								A.one('#<portlet:namespace /><%=PortletConfiguration.MAP_STYLES %>').val('');
							}
							
							document.<portlet:namespace />fm.<portlet:namespace />classNameIds.value = Liferay.Util.listSelect(document.<portlet:namespace />fm.<portlet:namespace />currentClassNameIds);
							document.<portlet:namespace />fm.<portlet:namespace />pluginIds.value = Liferay.Util.listSelect(document.<portlet:namespace />fm.<portlet:namespace />currentPluginIds);
							submitForm(document.<portlet:namespace />fm);
						},
						['liferay-util-list-fields']
					);
				</aui:script>
					
			</liferay-ui:section>
				
			<liferay-ui:section>
					
				<liferay-ui:error-marker key="errorSection" value="plugins" />
		
				<%
				PortletURL iteratorURL = renderResponse.createRenderURL();
				iteratorURL.setParameter("tabs2", "plugins");
				%>
				
				<liferay-ui:search-container
					iteratorURL="<%= iteratorURL %>"
					total="<%= plugins.size() %>"
				>
					<liferay-ui:search-container-results
						results="<%= ListUtil.subList(plugins,
						    searchContainer.getStart(), searchContainer.getEnd()) %>"
					/>
				
					<liferay-ui:search-container-row
						className="it.tref.liferay.mapit.map.model.Plugin"
						modelVar="plugin"
					>
					
						<liferay-ui:search-container-column-text name="name" property="name" />
						
						<liferay-ui:search-container-column-text name="version" property="version" />
							
						<liferay-ui:search-container-column-text>
						
							<liferay-ui:icon-menu>
							
								<%
								
								String portletConfigurationJsp = null;
								
								MapItPlugin mapItPlugin = MapItPluginUtil.getMapItPlugin(plugin.getContext());
								if (mapItPlugin != null) {
								  portletConfigurationJsp = mapItPlugin.getPortletConfigurationJsp();
								}
								%>
								
								<c:if test="<%=Validator.isNotNull(portletConfigurationJsp) && plugin.isActive()%>">
								
									<%
									
									PortletURL portletURL = renderResponse.createRenderURL();
									portletURL.setParameter("contextName", plugin.getContext());
									portletURL.setParameter("portletResource", portletResource);
									portletURL.setParameter("struts_action", "/portlet_configuration/edit_configuration");
									%>
								 
									<liferay-ui:icon
										image="configuration"
										message="configuration"
										localizeMessage="true"
										url="<%= portletURL.toString() %>"
									/>
								
								</c:if>
					
							</liferay-ui:icon-menu>
						
						</liferay-ui:search-container-column-text>
				
					</liferay-ui:search-container-row>
				
					<liferay-ui:search-iterator  />
					
				</liferay-ui:search-container>
				
			</liferay-ui:section>
			
		</liferay-ui:tabs>
		
	</c:otherwise>
</c:choose>
